/* xscreensaver, Copyright (c) 1997, 1998, 2002 Jamie Zawinski <jwz@jwz.org>
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.  No representations are made about the suitability of this
 * software for any purpose.  It is provided "as is" without express or 
 * implied warranty.
 *
 * Concept snarfed from Michael D. Bayne in
 * http://www.go2net.com/internet/deep/1997/04/16/body.html
 */

/* 
  * ported to Plan 9 by andrey@lanl.gov, 07/02
  */

/* plan9-related stuff */
#include "plan9.h"

static int ncolors = 255;
static int max_depth = 0;
static int min_height = 0;
static int min_width = 0;
static int current_color = 0;

static void
deco (int x, int y, int w, int h, int depth)
{
	Point pts[4];

	if (((random() % max_depth) < depth) || (w < min_width) || (h < min_height))
	{
		if (++current_color >= ncolors)
			current_color = 0;


		//      XFillRectangle (dpy, window, bgc, x, y, w, h);
		pts[0] = addpt(screen->r.min, Pt(x, y));
		pts[1] = addpt(pts[0], Pt(w, 0));
		pts[2] = addpt(pts[1], Pt(0, h));
		pts[3] = addpt(pts[0], Pt(0, h));
		fillpoly(screen, pts, 4, 1, colors[current_color], ZP);


		//      XDrawRectangle (dpy, window, fgc, x, y, w, h);
		pts[0] = addpt(screen->r.min, Pt(x, y));
		pts[1] = addpt(pts[0], Pt(w, 0));
		pts[2] = addpt(pts[1], Pt(0, h));
		pts[3] = addpt(pts[0], Pt(0, h));
		poly(screen, pts, 4, Endsquare, Endsquare, 1, display->black, ZP);
	}
	else
	{
		if (random() & 1)
		{
			deco (x, y, w/2, h, depth+1);
			deco (x+w/2, y, w/2, h, depth+1);
		}
		else
		{
			deco (x, y, w, h/2, depth+1);
			deco (x, y+h/2, w, h/2, depth+1);
		}
	}
}




void
screenhack (void)
{
	int delay = 5000;

	max_depth = 12;
	if (max_depth < 1) max_depth = 1;
	else if (max_depth > 1000) max_depth = 1000;

	min_width = 20;
	min_height = 20;


	while (1)
	{
		//      XFillRectangle(dpy, window, bgc, 0, 0, xgwa.width, xgwa.height);
		draw(screen, screen->r, colors[current_color], nil, ZP);

		deco (0, 0, Dx(screen->r), Dy(screen->r), 0);
		frames++;
		flushimage(display, 1);
		if(ecanmouse()) {
			m = emouse();
			if(m.buttons&4) {
				if(emenuhit(3, &m, &menu) == 0)
					threadexitsall(0);
			}
		}
		sleep (delay);

	}
}


void
eresized(int new)
{

	if(new && getwindow(display, Refnone) < 0) {
		sysfatal("can't reattach to window");
	}
	sysfatal("cannot resize");
}


void 
threadmain(int argc, char **argv)
{
	int i;

	ARGBEGIN{
	case 'b':
		btime = atol(EARGF(usage()));
		proccreate(dofps, nil, 8192);
		break;
	}
	ARGEND;

	srand(time(0));


	if(initdraw(nil, nil, "deco") < 0)
		sysfatal("initdraw failed: %r");

	for(i = 0; i < 256; i++)
		colors[i] = allocimage(display, Rect(0, 0, 1, 1), screen->chan, 1, cmap2rgba(i<<2));

	einit(Emouse);
	screenhack();
}
