/* xscreensaver, Copyright (c) 1997, 1998, 2001 Jamie Zawinski <jwz@jwz.org>
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.  No representations are made about the suitability of this
 * software for any purpose.  It is provided "as is" without express or 
 * implied warranty.
 *
 * Concept snarfed from Michael D. Bayne in
 * http://www.go2net.com/internet/deep/1997/04/16/body.html
 */

/*
 * Ported to Plan 9 by mirtchov@cpsc.ucalgary.ca, 09/03
 */

/* plan9-related stuff */
#include "plan9.h"

#include "smooth.h"
uchar col[256];


static int offset = 0;
static int ncolors = 256;
static unsigned long fg_pixel = 0;
static unsigned long bg_pixel = 0;

static void
init_moire (void)
{
	offset = 50;

	ncolors = 256;

	smoothcmap(col);
}


static void
moire (int offset)
{
	long x, y, xo, yo;
	int factor = (random() % offset)+1;

	xo = (random() % Dx(screen->r))  - Dx(screen->r)/2;
	yo = (random() % Dy(screen->r)) - Dy(screen->r)/2;

	for (y = 0; y < Dy(screen->r); y++)
	{
		for (x = 0; x < Dx(screen->r); x++)
		{
			double xx = x + xo;
			double yy = y + yo;
			double i = ((xx * xx) + (yy * yy)) / (double) factor;

			//XPutPixel (image, x, 0, gcv.foreground);
			buf[y*Dx(screen->r) + x] = col[((long) i) % ncolors];
			//draw(screen, rectaddpt(Rect(x, y, x+1, y+1), screen->r.min), col[((long) i) % ncolors], nil, ZP);
		}


		//XPutImage (dpy, window, gc, image, 0, 0, 0, y, xgwa.width, 1);
		//flushimage(display, 1);
	}
	//flushimage(display, 1);
	loadimage(img, Rpt(Pt(0, 0), Pt(Dx(screen->r), Dy(screen->r))), buf, Dx(screen->r)*Dy(screen->r));
	draw(screen, screen->r, img, nil, ZP);

}

void
screenhack (void)
{
	while (1)
	{
		init_moire ();
		moire (offset);
		flushimage(display, 1);
		frames++;
		if(ecanmouse()) {
			m = emouse();
			if(m.buttons&4) {
				if(emenuhit(3, &m, &menu) == 0)
					threadexitsall(0);
			}
		}
		sleep(1000);
	}
}

void
eresized(int new)
{

	if(new && getwindow(display, Refnone) < 0) {
		sysfatal("can't reattach to window");
	}

	fprint(2, "resize not supported...\n");
	threadexitsall("resize not supported");

}


void 
threadmain(int argc, char **argv)
{

	ARGBEGIN{
	case 'b':
		btime = atol(EARGF(usage()));
		proccreate(dofps, nil, 8192);
		break;
	}
	ARGEND;
	srand(time(0));


	if(initdraw(nil, nil, "moire") < 0)
		sysfatal("initdraw failed: %r");

	einit(Emouse);

	buf = malloc(Dx(screen->r)*Dy(screen->r));
	if(buf == nil)
		sysfatal("cannot malloc buffer: %r\n");

	img = allocimage(display, Rpt(Pt(0, 0), Pt(Dx(screen->r), Dy(screen->r))), CMAP8, 1, DCyan);
	if(img == nil)
		sysfatal("cannot allocate image: %r\n");

	screenhack();
}
