/* xscreensaver, Copyright (c) 1992, 1996, 1998, 2001
 *  Jamie Zawinski <jwz@jwz.org>
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.  No representations are made about the suitability of this
 * software for any purpose.  It is provided "as is" without express or 
 * implied warranty.
 *
 * 19971004: Johannes Keukelaar <johannes@nada.kth.se>: Use helix screen
 *           eraser.
 */

/* 
  * ported to Plan 9 by andrey@lanl.gov, 08/02
  */

/* plan9-related stuff */
#include "plan9.h"

Image *color;

static unsigned int default_fg_pixel;
static int iterations, offset;
static Bool xsym, ysym;
static int sleep_time;

static void
init_rorschach (void)
{
	iterations = 40000;
	offset = 4;
	xsym = 1;
	ysym = 0;
}

static void
hurm (void)
{
	int i2;
	int xlim, ylim, x, y, i;
	XPoint points [4];

	draw(screen, screen->r, display->black, nil, ZP);
	xlim = Dx(screen->r);
	ylim = Dy(screen->r);


	x = xlim/2;
	y = ylim/2;
	for (i = 0; i < iterations; i++)
	{
		int j = 0;
		x += ((random () % (1 + (offset << 1))) - offset);
		y += ((random () % (1 + (offset << 1))) - offset);
		points [j].x = x;
		points [j].y = y;
		j++;
		if (xsym)
		{
			points [j].x = xlim - x;
			points [j].y = y;
			j++;
		}
		if (ysym)
		{
			points [j].x = x;
			points [j].y = ylim - y;
			j++;
		}
		if (xsym && ysym)
		{
			points [j].x = xlim - x;
			points [j].y = ylim - y;
			j++;
		}
		//      XDrawPoints (dpy, window, draw_gc, points, j, CoordModeOrigin);
		for(i2 = 0; i2 < j; i2++) {
			Rectangle r;
			Point p = screen->r.min;

			p = addpt(p, points[i2]);
			r = Rpt(p, addpt(p, Pt(1,1)));
			draw(screen, r, color, nil, ZP);

		}

		flushimage(display, 1);
		if(ecanmouse()) {
			m = emouse();
			if(m.buttons&4) {
				if(emenuhit(3, &m, &menu) == 0)
					threadexitsall(0);
			}
		}
	}
	sleep ( sleep_time );

	draw(screen, screen->r, display->black, nil, ZP);

	flushimage(display, 1);
	frames++;

	if(ecanmouse()) {
		m = emouse();
		if(m.buttons&4) {
			if(emenuhit(3, &m, &menu) == 0)
				threadexitsall(0);
		}
	}
	sleep (1);
}



void
screenhack (void)
{
	sleep_time = 5000;
	init_rorschach ();
	while (1)
		hurm ();
}


void
eresized(int new)
{

	if(new && getwindow(display, Refnone) < 0) {
		sysfatal("can't reattach to window");
	}
	sysfatal("cannot resize");
}


void 
threadmain(int argc, char **argv)
{

	ARGBEGIN{
	case 'b':
		btime = atol(EARGF(usage()));
		proccreate(dofps, nil, 8192);
		break;
	}
	ARGEND;
	srand(time(0));


	if(initdraw(nil, nil, "rorschach") < 0)
		sysfatal("initdraw failed: %r");


	color = allocimage(display, Rect(0, 0, 1, 1), screen->chan, 1, cmap2rgba(nrand(65536)));
	einit(Emouse);
	screenhack();
}
