/* Make a snapshot of the screen and display it "squeezed" in
 * a rio window
 */

/* written by mirtchov@cpsc.ucalgary.ca */

/* plan9-related stuff */
#include <u.h>
#include <libc.h>
#include <draw.h>
#include <event.h>
#include <thread.h>

/* screenshot-related stuff */
#include "squeeze.h"	
static Image *img;

vlong tbegin, tend;
ulong frames, btime;

void
dofps(void *)
{
	tbegin = nsec();
	sleep(btime*1000);	/* in milliseconds */
	tend = nsec();
	print("fps: %uf\n", frames/((tend - tbegin)/1000000000.0));

	threadexitsall(nil);
}

int cont;

char *buttons[] = 
{
	"exit",
	0
};

Menu menu = 
{
	buttons
};

Mouse m;
/* end of plan9-related defines */



void
eresized(int new)
{

	if(new && getwindow(display, Refnone) < 0) {
		sysfatal("can't reattach to window: %r");
	}

	img = allocimage(display, Rect(0, 0, Dx(screen->r), Dy(screen->r)), screen->chan, 0, DBlack);
	if(img == nil)
		sysfatal("cannot allocate image: %r");

	img = resample(display->image, img);
	if(img == nil)
		sysfatal("unable to fit screenshot to window: %r");

	draw(screen, screen->r, img, nil, ZP);
	frames++;
	flushimage(display, 1);
}

void 
usage(void)
{
	print("usage: %s [-c] [-b btime]\n", argv0);
	threadexitsall("usage");
}


void 
threadmain(int argc, char **argv)
{
	int i = 0;

	ARGBEGIN{
	case 'b':
		btime = atol(EARGF(usage()));
		proccreate(dofps, nil, 8192);
		break;
	case 'c':
		cont = 1;
		break;
	}
	ARGEND;

	srand(time(0));

	if(initdraw(nil, nil, "scrdump") < 0)
		sysfatal("initdraw failed: %r");

	einit(Emouse);
	eresized(0);

	while (1) {
		if(ecanmouse()) {
			m = emouse();
			if(m.buttons&4)
				if(emenuhit(3, &m, &menu) == 0)
					threadexitsall(0);
		}
		if(cont && i++ > 100) {
			i = 0;

			img = resample(display->image, img);
			if(img == nil)
				sysfatal("unable to fit screenshot to window: %r");

			draw(screen, screen->r, img, nil, ZP);
			flushimage(display, 1);
		} else {
			sleep(100);
		}

	}
}
